/* step5 h~m| @*/
#include "dm5.h"
#define DOMINO_NUM  21

static int STEPS = 0;   // V~[ṼXebv
int mode = 0;
double domino_height = 0.65;
double red[3] = {1.3, 0.0, 0.0}; // ԐF
dmObject domino[DOMINO_NUM]; // h~m
dmObject domino2[DOMINO_NUM]; // h~m

void simLoop(int pause)           /***  V~[V[v@***/
{

    int i;
    double x = 5.0, y = 0, z = 1; // J̈ʒu[m]
    double yaw = -180, pitch = 0, roll = 0; // J̎p@[Csb`C[p[]

    if (STEPS == 0) dmSetCamera(x,y,z,yaw,pitch,roll); // J̐ݒ

    dmSimQuickStep(); // V~[VPXebvi߂()

    for (i = 0; i < DOMINO_NUM; i++)
    {
        dmDraw(&domino[i]); //@h~m̕`
        if (mode == 2) {
            if (i != (int) DOMINO_NUM/2) {
                dmDraw(&domino2[i]); // h~m̕`
            }
        }
    }
    STEPS++;
}

void resetSim()
{
    double m = 0.1; // 
    double side[3] = {0.2, 0.05, domino_height}; // TCY
    static double R[12] = {1,0,0,0, 0,1,0,0, 0,0,1,0}; // p
    static double R2[12] = {1,0,0,0, 0,1,0,0, 0,0,1,0}; // p
    double p[DOMINO_NUM][3];  // ʒu
    double p2[DOMINO_NUM][3];

    int i;

    // V~[V̏I
    if (STEPS != 0)
    {
        dmClose();
    }

    dmInit(); // 

    // h~m̐
    for (i = 0; i < DOMINO_NUM; i++)
    {
        p[i][2]  = domino_height/2; // h~mdSzW
        p2[i][2] = domino_height/2;
        switch (mode)
        {
        case 0:
            p[i][0] = 0;             // h~mdSxW
            p[i][1] = 0.3 * i -3.0;  // h~mdSyW
            break;
        case 1:
            p[i][0] = 0.3 * i -3.0;
            p[i][1] = p[i][0];
            // zɃ/4]p@
            dRFromAxisAndAngle(R, 0, 0, 1, - M_PI/4);
            break;
        case 2:
            // z-/4]p@
            dRFromAxisAndAngle(R,  0, 0, 1, - M_PI/4);
            dRFromAxisAndAngle(R2, 0, 0, 1,   M_PI/4);

            p[i][0] = 0.3 * i -3.0;
            p[i][1] = p[i][0];

            if (i != (int) DOMINO_NUM/2)
            {
                p2[i][0] = 0.3 * i -3.0;
                p2[i][1] = - p2[i][0];
                dmCreateBox(&domino2[i], p2[i], R2, m, side, red);
            }
            break;
        default:
            printf("Bad number \n");
            break;
        }
        dmCreateBox(&domino[i], p[i], R, m, side, red);
    }
}

void command(int cmd)
{
    switch (cmd)
    {
    case '1':
        mode = 1;
        resetSim();
        break;
    case '2':
        mode = 2;
        resetSim();
        break;
    case 'r':
    case 'R':
        mode = 0;
        resetSim();
        break;
    case 'f':
    case 'F':
    {
        double fx = -1.0, fy = 1.0, fz = 0.0;
        dmAddTorque(&domino[0], fx, fy, fz); // x,y,z܂fx,fy,fz̃gNt
        if (mode == 2) {
               dmAddTorque(&domino2[0], -fx, fy, fz); // x,y,z܂fx,fy,fz̃gNt
        }
        break;
    }
    default:
        printf("Input r, R, f, F key \n");
        break;
    }
}

/*** main֐ ***/
int main()
{
    resetSim(); // V~[ṼZbg
    dmLoop(800, 600, simLoop, command);  // EChE̕C, [v֐CR}h֐
    dmClose(); // I

    return 0;
}




